From: "Michael D Kinney" <michael.d.kinney@intel.com>
To: devel@edk2.groups.io
Cc: Andrew Fish <afish@apple.com>,
Jordan Justen <jordan.l.justen@intel.com>,
Ray Ni <ray.ni@intel.com>
Subject: [Patch V5 06/11] EmulatorPkg: Fix XCODE5 lldb issues
Date: Fri, 16 Aug 2019 17:57:10 -0700 [thread overview]
Message-ID: <20190817005715.9856-7-michael.d.kinney@intel.com> (raw)
In-Reply-To: <20190817005715.9856-1-michael.d.kinney@intel.com>
From: Andrew Fish <afish@apple.com>
Fix scripts to support lldb symbolic debugging when
using XCODE5 tool chain.
Cc: Jordan Justen <jordan.l.justen@intel.com>
Cc: Ray Ni <ray.ni@intel.com>
Cc: Michael D Kinney <michael.d.kinney@intel.com>
Signed-off-by: Andrew Fish <afish@apple.com>
Reviewed-by: Michael D Kinney <michael.d.kinney@intel.com>
Tested-by: Andrew Fish <afish@apple.com>
---
EmulatorPkg/Unix/lldbefi.py | 8 +++++---
EmulatorPkg/build.sh | 21 ++++++---------------
2 files changed, 11 insertions(+), 18 deletions(-)
diff --git a/EmulatorPkg/Unix/lldbefi.py b/EmulatorPkg/Unix/lldbefi.py
index 218326b8cb..099192d8b5 100755
--- a/EmulatorPkg/Unix/lldbefi.py
+++ b/EmulatorPkg/Unix/lldbefi.py
@@ -346,6 +346,7 @@ def TypePrintFormating(debugger):
debugger.HandleCommand("type summary add CHAR8 --python-function lldbefi.CHAR8_TypeSummary")
debugger.HandleCommand('type summary add --regex "CHAR8 \[[0-9]+\]" --python-function lldbefi.CHAR8_TypeSummary')
+ debugger.HandleCommand('setting set frame-format "frame #${frame.index}: ${frame.pc}{ ${module.file.basename}{:${function.name}()${function.pc-offset}}}{ at ${line.file.fullpath}:${line.number}}\n"')
gEmulatorBreakWorkaroundNeeded = True
@@ -381,15 +382,16 @@ def LoadEmulatorEfiSymbols(frame, bp_loc , internal_dict):
Error = lldb.SBError()
FileNamePtr = frame.FindVariable ("FileName").GetValueAsUnsigned()
FileNameLen = frame.FindVariable ("FileNameLength").GetValueAsUnsigned()
+
FileName = frame.thread.process.ReadCStringFromMemory (FileNamePtr, FileNameLen, Error)
if not Error.Success():
print "!ReadCStringFromMemory() did not find a %d byte C string at %x" % (FileNameLen, FileNamePtr)
# make breakpoint command contiue
- frame.GetThread().GetProcess().Continue()
+ return False
debugger = frame.thread.process.target.debugger
if frame.FindVariable ("AddSymbolFlag").GetValueAsUnsigned() == 1:
- LoadAddress = frame.FindVariable ("LoadAddress").GetValueAsUnsigned()
+ LoadAddress = frame.FindVariable ("LoadAddress").GetValueAsUnsigned() - 0x240
debugger.HandleCommand ("target modules add %s" % FileName)
print "target modules load --slid 0x%x %s" % (LoadAddress, FileName)
@@ -405,7 +407,7 @@ def LoadEmulatorEfiSymbols(frame, bp_loc , internal_dict):
print "!lldb.target.RemoveModule (%s) FAILED" % SBModule
# make breakpoint command contiue
- frame.thread.process.Continue()
+ return False
def GuidToCStructStr (guid, Name=False):
#
diff --git a/EmulatorPkg/build.sh b/EmulatorPkg/build.sh
index 60056e1b6c..76c22dfaf8 100755
--- a/EmulatorPkg/build.sh
+++ b/EmulatorPkg/build.sh
@@ -209,21 +209,12 @@ fi
if [[ "$RUN_EMULATOR" == "yes" ]]; then
case `uname` in
Darwin*)
- #
- # On Darwin we can't use dlopen, so we have to load the real PE/COFF images.
- # This .gdbinit script sets a breakpoint that loads symbols for the PE/COFFEE
- # images that get loaded in Host
- #
- if [[ "$CLANG_VER" == *-ccc-host-triple* ]]
- then
- # only older versions of Xcode support -ccc-host-tripe, for newer versions
- # it is -target
- cp $WORKSPACE/EmulatorPkg/Unix/lldbefi.py "$BUILD_OUTPUT_DIR/${BUILDTARGET}_$TARGET_TOOLS/$PROCESSOR"
- cd $BUILD_ROOT_ARCH; /usr/bin/lldb --source $WORKSPACE/EmulatorPkg/Unix/lldbinit Host
- exit $?
- else
- cp $WORKSPACE/EmulatorPkg/Unix/.gdbinit "$BUILD_OUTPUT_DIR/${BUILDTARGET}_$TARGET_TOOLS/$PROCESSOR"
- fi
+ cd $BUILD_ROOT_ARCH
+ /usr/bin/lldb \
+ -o "command script import $WORKSPACE/EmulatorPkg/Unix/lldbefi.py" \
+ -o 'script lldb.debugger.SetAsync(True)' \
+ -o "run" ./Host
+ exit $?
;;
esac
--
2.21.0.windows.1
next prev parent reply other threads:[~2019-08-17 0:57 UTC|newest]
Thread overview: 14+ messages / expand[flat|nested] mbox.gz Atom feed top
2019-08-17 0:57 [Patch V5 00/11] EmulatorPkg: Fix VS20xx IA32 boot and simplify build config Michael D Kinney
2019-08-17 0:57 ` [Patch V5 01/11] EmulatorPkg: Fix VS20xx IA32 boot failure Michael D Kinney
2019-08-17 0:57 ` [Patch V5 02/11] EmulatorPkg: Remove UNIX_SEC_BUILD/WIN_SEC_BUILD Michael D Kinney
2019-08-17 0:57 ` [Patch V5 03/11] EmulatorPkg: Add -D DISABLE_NEW_DEPRECATED_INTERFACES Michael D Kinney
2019-08-17 0:57 ` [Patch V5 04/11] EmulatorPkg: Add support for NOOPT target Michael D Kinney
2019-08-17 0:57 ` [Patch V5 05/11] EmulatorPkg/Unix/Host: Disable inline/optimizations Michael D Kinney
2019-08-17 0:57 ` Michael D Kinney [this message]
2019-08-17 0:57 ` [Patch V5 07/11] EmulatorPkg/Unix/Host: Initialize field in BerkeleyPacketFilter.c Michael D Kinney
2019-08-17 0:57 ` [Patch V5 08/11] EmulatorPkg/Unix/Host: Remove debug code from BerkeleyPacketFilter.c Michael D Kinney
2019-08-17 0:57 ` [Patch V5 09/11] EmulatorPkg: Disable TftpDynamicCommand and LogoDxe for XCODE5 Michael D Kinney
2019-08-17 0:57 ` [Patch V5 10/11] EmulatorPkg/Sec: Change scope of PpiArray[10] Michael D Kinney
2019-08-17 0:57 ` [Patch V5 11/11] BaseTools/tools_def.template: Add -gdwarf to XCODE5 X64 Michael D Kinney
2019-08-19 2:42 ` [Patch V5 00/11] EmulatorPkg: Fix VS20xx IA32 boot and simplify build config Jordan Justen
2019-08-19 16:59 ` Michael D Kinney
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-list from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20190817005715.9856-7-michael.d.kinney@intel.com \
--to=devel@edk2.groups.io \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox